(*******************************************************************************
 *                           "whatsnew"
 *  An Utility program which find html files modified lateley.
 *              Copyright (C) 2001-2004  Fumio KAWAMATA
 *       The "whatsnew" is free software distributed under GNU GPL
 ******************************************************************************
 *)
unit htmltitle;

interface

function GetHTMLTitle(FileName: string): string;

implementation

uses SysUtils, jconvert;


function GetTitlePart(FileName: string): string;
var
    BetweenTitle:     Boolean;
    ExitDo:           Boolean;
    HTMLFile:         text;
    Statement:        string;
begin
  Result:='';
  AssignFile(HTMLFile, FileName);
  try
    Reset(HTMLFile);
  except
    Result:='(Error: Could not read file because of the File I/O Error)';
    Exit;
  end;
  ExitDo:=False;
  BetweenTitle:=False;
  while not(Eof(HTMLFile)) and (ExitDo=False) do
  begin
    readln(HTMLFile,Statement);
    Statement:=jconvert.ConvertJCode(Statement,SJIS_OUT);
    if (pos('<TITLE>',UpperCase(Statement))>0)and
       (pos('</TITLE>',UpperCase(Statement))>0) then
    begin
      Result:=Statement;
      ExitDo:=True;
    end;

    if (BetweenTitle=False)and(pos('<TITLE>',UpperCase(Statement))>0) then
    begin
      BetweenTitle:=True;
      Result:=Statement;
    end
    else
    if BetweenTitle=True then
    begin
      Result:=Result+Statement;
      if pos('</TITLE>',UpperCase(Statement))>0 then
        ExitDo:=True;
    end;
  end;
  CloseFile(HTMLFile);
end;



function GetHTMLTitle(FileName: string): string;
var
  TitlePart:   string;
  UpperCased:  string;
  P1:          Integer;
  P2:          Integer;
begin
  TitlePart:=GetTitlePart(FileName);
  UpperCased:=AnsiUpperCase(TitlePart);
  P1:=pos('<TITLE>', UpperCased);
  P2:=pos('</TITLE>',UpperCased);
  if P2<P1 then
  begin
    Result:='(Error: </TITLE> appears before <TITLE>)';
    Exit;
  end;
  if (P1=0) or (P2=0) then
  begin
    Result:='(Error: No title or uncompleted <TITLE>)';
    Exit;
  end;
  Result:=copy(TitlePart,P1+7,P2-(P1+7));
  if Result='' then
    Result:='(None title)';
end;

end.
